unit UnitFrmRatTrap;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls;

type
  TFrmRatTrap = class(TForm)
    TimAutoHide: TTimer;
    procedure FormShow(Sender: TObject);
    procedure TimAutoHideTimer(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public declarations }
    procedure ReportMouse(pt : TPoint);
    procedure ReportDirectionChange;
  end;

var
  FrmRatTrap: TFrmRatTrap;

implementation

{$R *.dfm}

uses UnitFrmMouseMonitor;

procedure TFrmRatTrap.CreateParams(var Params: TCreateParams);
begin
    //ControlStyle := ControlStyle - [csOpaque];
    //Brush.Style := bsClear;
   	inherited;

    Params.Style := WS_POPUP and not WS_CAPTION {and WS_BORDER};
    Params.ExStyle := WS_EX_TOOLWINDOW or WS_EX_TOPMOST or WS_EX_NOACTIVATE;
end;

procedure TFrmRatTrap.FormHide(Sender: TObject);
begin
    TimAutoHide.Enabled := false;
end;

procedure TFrmRatTrap.FormShow(Sender: TObject);
var pt : TPoint;
    m : TMonitor;
begin
    self.WindowState := wsNormal;
    m := screen.MonitorFromPoint(mouse.CursorPos);
    self.Top := m.Top;
    Self.Left := m.Left;
    self.WindowState := wsMaximized;

    TimAutoHide.Enabled := true;

    Canvas.Brush.Color := clBtnFace;
    canvas.Rectangle(self.ClientRect);

    pt := Self.ScreenToClient( point(FrmMouseMonitor.prStartingX,frmMouseMonitor.prStartingy) );
    canvas.moveto(pt.y, pt.y);
    Canvas.PenPos := pt;

    Canvas.Pen.Color := clblack;
    Canvas.Pen.Width := 2;
    Canvas.Pen.Style := psSolid;
end;

procedure TFrmRatTrap.TimAutoHideTimer(Sender: TObject);
begin
    self.Visible := False;
    TimAutoHide.Enabled := false;
end;

procedure TFrmRatTrap.ReportMouse(pt : TPoint);
begin
    pt := ScreenToClient(pt);

    if pt <> canvas.PenPos then begin
        Canvas.MoveTo(Canvas.PenPos.X, Canvas.PenPos.y);
        Canvas.LineTo(pt.X, pt.y);
    end;

    Canvas.Pixels[pt.X, pt.Y] := clBlack;
end;


procedure TFrmRatTrap.ReportDirectionChange;
begin
end;
end.
